
#pragma used+

char *strcat(char *str1,char *str2);
char *strcatf(char *str1,char flash *str2);
char *strchr(char *str,char c);
signed char strcmp(char *str1,char *str2);
signed char strcmpf(char *str1,char flash *str2);
char *strcpy(char *dest,char *src);
char *strcpyf(char *dest,char flash *src);
unsigned char strlcpy(char *dest,char *src,unsigned char n);	
unsigned char strlcpyf(char *dest,char flash *src,unsigned char n); 
unsigned int strlenf(char flash *str);
char *strncat(char *str1,char *str2,unsigned char n);
char *strncatf(char *str1,char flash *str2,unsigned char n);
signed char strncmp(char *str1,char *str2,unsigned char n);
signed char strncmpf(char *str1,char flash *str2,unsigned char n);
char *strncpy(char *dest,char *src,unsigned char n);
char *strncpyf(char *dest,char flash *src,unsigned char n);
char *strpbrk(char *str,char *set);
char *strpbrkf(char *str,char flash *set);
char *strrchr(char *str,char c);
char *strrpbrk(char *str,char *set);
char *strrpbrkf(char *str,char flash *set);
char *strstr(char *str1,char *str2);
char *strstrf(char *str1,char flash *str2);
char *strtok(char *str1,char flash *str2);

unsigned int strlen(char *str);
void *memccpy(void *dest,void *src,char c,unsigned n);
void *memchr(void *buf,unsigned char c,unsigned n);
signed char memcmp(void *buf1,void *buf2,unsigned n);
signed char memcmpf(void *buf1,void flash *buf2,unsigned n);
void *memcpy(void *dest,void *src,unsigned n);
void *memcpyf(void *dest,void flash *src,unsigned n);
void *memmove(void *dest,void *src,unsigned n);
void *memset(void *buf,unsigned char c,unsigned n);
unsigned int strcspn(char *str,char *set);
unsigned int strcspnf(char *str,char flash *set);
int strpos(char *str,char c);
int strrpos(char *str,char c);
unsigned int strspn(char *str,char *set);
unsigned int strspnf(char *str,char flash *set);

#pragma used-
#pragma library string.lib

#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      
sfrb ADCSRA=6;
sfrb ADCSR=6;     
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb OCR0=0X3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

#pragma used+

unsigned char cabs(signed char x);
unsigned int abs(int x);
unsigned long labs(long x);
float fabs(float x);
int atoi(char *str);
long int atol(char *str);
float atof(char *str);
void itoa(int n,char *str);
void ltoa(long int n,char *str);
void ftoa(float n,unsigned char decimals,char *str);
void ftoe(float n,unsigned char decimals,char *str);
void srand(int seed);
int rand(void);
void *malloc(unsigned int size);
void *calloc(unsigned int num, unsigned int size);
void *realloc(void *ptr, unsigned int size); 
void free(void *ptr);

#pragma used-
#pragma library stdlib.lib

typedef char *va_list;

#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);
int printf(char flash *fmtstr,...);
int sprintf(char *str, char flash *fmtstr,...);
int vprintf(char flash * fmtstr, va_list argptr);
int vsprintf(char *str, char flash * fmtstr, va_list argptr);

char *gets(char *str,unsigned int len);
int snprintf(char *str, unsigned int size, char flash *fmtstr,...);
int vsnprintf(char *str, unsigned int size, char flash * fmtstr, va_list argptr);

int scanf(char flash *fmtstr,...);
int sscanf(char *str, char flash *fmtstr,...);

typedef unsigned char DSTATUS;

typedef enum {
RES_OK = 0,		
RES_ERROR,		
RES_WRPRT,		
RES_NOTRDY,		
RES_PARERR		
} DRESULT;

DSTATUS disk_initialize (unsigned char drv);
DSTATUS disk_status (unsigned char drv);
DRESULT disk_read (unsigned char drv, unsigned char* buff, unsigned long sector, unsigned char count);
DRESULT disk_write (unsigned char drv, const unsigned char* buff, unsigned long sector, unsigned char count);
DRESULT disk_ioctl (unsigned char drv, unsigned char ctrl, void* buff);
void disk_timerproc (void);

#pragma library sdcard.lib

typedef char XCHAR;		

typedef struct _FATFS_ {
unsigned char	fs_type;	
unsigned char	drive;		
unsigned char	csize;		
unsigned char	n_fats;		
unsigned char	wflag;		
unsigned char	fsi_flag;	
unsigned short	id;		
unsigned short	n_rootdir;	
unsigned long	last_clust;	
unsigned long	free_clust;	
unsigned long	fsi_sector;	
unsigned long	cdir;		
unsigned long	sects_fat;	
unsigned long	max_clust;	
unsigned long	fatbase;	
unsigned long	dirbase;	
unsigned long	database;	
unsigned long	winsect;	
unsigned char	win[512];
} FATFS;

typedef struct _DIR_ {
FATFS*	fs;			
unsigned short	id;		
unsigned short	index;	
unsigned long	sclust;	
unsigned long	clust;	
unsigned long	sect;	
unsigned char*	dir;		
unsigned char*	fn;		
} DIR;

typedef struct _FIL_ {
FATFS*	fs;			
unsigned short	id;		
unsigned char	flag;	
unsigned char	csect;	
unsigned long	fptr;		
unsigned long	fsize;		
unsigned long	org_clust;	
unsigned long	curr_clust;	
unsigned long	dsect;		
unsigned long	dir_sect;	
unsigned char*	dir_ptr;	
unsigned char	buf[512];
} FIL;

typedef struct _FILINFO_ {
unsigned long	fsize;	
unsigned short	fdate;	
unsigned short	ftime;	
unsigned char	fattrib;	
char	fname[13];	
} FILINFO;

typedef enum {
FR_OK = 0,		
FR_DISK_ERR,		
FR_INT_ERR,		
FR_NOT_READY,		
FR_NO_FILE,		
FR_NO_PATH,		
FR_INVALID_NAME,	
FR_DENIED,		
FR_EXIST,			
FR_INVALID_OBJECT,	
FR_WRITE_PROTECTED,	
FR_INVALID_DRIVE,	
FR_NOT_ENABLED,	
FR_NO_FILESYSTEM,	
FR_MKFS_ABORTED,	
FR_TIMEOUT		
} FRESULT;

FRESULT f_mount (unsigned char vol , FATFS* fs);

FRESULT f_open (FIL* fp, const XCHAR* path, unsigned char mode);

FRESULT f_read (FIL* fp, void* buff, unsigned int btr, unsigned int* br);

FRESULT f_write (FIL* fp, const void* buff, unsigned int btw, unsigned int* bw);

FRESULT f_lseek (FIL* fp, unsigned long ofs);

FRESULT f_close (FIL* fp);

FRESULT f_opendir (DIR* dj, const XCHAR* path);

FRESULT f_readdir (DIR* dj, FILINFO* fno);

FRESULT f_stat (const XCHAR* path, FILINFO* fno);

FRESULT f_getfree (const XCHAR* path, unsigned long* nclst, FATFS** fatfs);

FRESULT f_truncate (FIL* fp);

FRESULT f_sync (FIL* fp);

FRESULT f_unlink (const XCHAR* path);

FRESULT f_mkdir (const XCHAR* path);

FRESULT f_chmod (const XCHAR* path, unsigned char value, unsigned char mask);

FRESULT f_utime (const XCHAR* path, const FILINFO* fno);

FRESULT f_rename (const XCHAR* path_old, const XCHAR* path_new);

FRESULT f_chdir (const XCHAR* path);

FRESULT f_chdrive (unsigned char drv);

extern void (*prtc_get_time) (unsigned char *hour, unsigned char *min, unsigned char *sec);

extern void (*prtc_get_date) (unsigned char *date, unsigned char *month, unsigned *year);

#pragma library ff.lib

int fgetc(FIL *fp);
char *fgets(char *str,unsigned int len,FIL *fp);
int fputc(char k,FIL* fp);
int fputs(char *str,FIL* fp);
int fputsf(char flash *str,FIL* fp);
int fprintf(FIL *fp, char flash *fmtstr,...);
int fscanf(FIL *fp, char flash *fmtstr,...);
unsigned char feof(FIL* fp);
unsigned char ferror(FIL *fp);

#pragma used-

#pragma library stdio.lib

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

#pragma used+

unsigned char isalnum(char c);
unsigned char isalpha(char c);
unsigned char isascii(char c);
unsigned char iscntrl(char c);
unsigned char isdigit(char c);
unsigned char islower(char c);
unsigned char isprint(char c);
unsigned char ispunct(char c);
unsigned char isspace(char c);
unsigned char isupper(char c);
unsigned char isxdigit(char c);
unsigned char toint(char c);
char tolower(char c);
char toupper(char c);

#pragma used-

#pragma library ctype.lib

typedef signed char             								int8;
typedef unsigned char           								uint8;
typedef signed int              								int16;
typedef unsigned int            								uint16;
typedef signed long int         								int32;
typedef unsigned long int       								uint32;

typedef enum {
TFT_MODE_NORMAL,
TFT_MODE_INVERSE,
TFT_MODE_FULL
} TFT_mode_t;

extern int 																	TFT_margin_xl;
extern int 																	TFT_margin_xr;
extern int 																	TFT_margin_yu;
extern int 																	TFT_margin_yl;

void TFTOutCmd(unsigned short ins);
void TFTOutDat(unsigned short dat); 											
void TFTOutDat2(unsigned char dath, unsigned char datl); 	

unsigned short TFTInDat(void); 														

void TFTSetReg(unsigned short index,unsigned short val); 	
unsigned short TFTGetReg(unsigned short index); 					

void TFTInit(void); 

void TFTBacklight(unsigned char x);
unsigned short TFTGetID(void);

void TFTSetArea(int sx,int ex,int sy,int ey);
void TFTResetArea(void);

void TFTGotoXY(int x,int y);

void TFTPutPixel(int x,int y,unsigned short color,TFT_mode_t mode);
void TFTFillRect(int sx,int ex,int sy,int ey,unsigned short color,TFT_mode_t mode); 

void TFTShowPic(int sx,int ex,int sy,int ey,const unsigned short *pic,TFT_mode_t mode);

extern void Line(unsigned int x1, unsigned int y1, unsigned int x2, unsigned int y2, unsigned short color);
extern void Rectangle(unsigned int x1, unsigned int y1, unsigned int x2, unsigned int y2, unsigned short color);
extern void RoundRectangle(unsigned int x1, unsigned int y1, unsigned int x2, unsigned int y2, unsigned int radius, unsigned char fill, unsigned short color);
extern void Circle_Fill(unsigned int x, unsigned int y, unsigned int radius, unsigned char fill, unsigned short color);

typedef enum {
E_LETTER,
P_LETTER
} Lt_Mode;

extern void LcdFont(flash unsigned char *pointer);

extern void LcdRot(unsigned char r);
extern void LcdReverse(unsigned char rv);
extern void LcdHorizontal(unsigned char hv);

extern void LcdFontFixed(unsigned char typ);
extern void	LcdNonTransparence(unsigned char nt);

extern void	LcdFgColor(unsigned short color);
extern void	LcdBkColor(unsigned short color);

extern void SetLine(unsigned char line,unsigned char column);

extern unsigned int CalcTextWidth(char *Text);
extern unsigned int CalcTextHeight(char *Text);

extern void PutChar(unsigned char c);
extern void Puts(char *Text);
extern void PutsP(char *Text);

extern void PutLong(unsigned long src, unsigned char digit, unsigned char decimal, unsigned char Parameter);
extern void PutInt(unsigned short src, unsigned char digit, unsigned char decimal, unsigned char Parameter);
extern void PutByte(unsigned char src, unsigned char digit, unsigned char decimal, unsigned char Parameter);

extern void PutText(unsigned short left, unsigned short top, unsigned short right, unsigned short bottom, char *str, unsigned char style);
extern void PutTextP(unsigned short left, unsigned short top, unsigned short right, unsigned short bottom, const char *str, unsigned char style);
extern void TextBox(unsigned short x1, unsigned short y1, unsigned short x2, unsigned short y2, char *str, unsigned char style);
extern void TextBoxP(unsigned short x1, unsigned short y1, unsigned short x2, unsigned short y2, char *str, unsigned char style);

extern void SetLetter(Lt_Mode L);
extern void PutsPE(char *str);

extern void PutCharPE(unsigned char c);
extern void PutCharEN(unsigned char c);

extern unsigned int CalcTextWidthEN(char *str);
extern unsigned int CalcTextWidthPE(char *str);

extern unsigned char 							rot;
extern unsigned char 							Reverse;
extern unsigned char							Horizontal;

extern unsigned short							FgColor;
extern unsigned short							BkColor;
extern unsigned char							FontFixed;
extern unsigned char							NonTransparence;

extern unsigned char 							FontWidth;
extern unsigned char 							FontHeight;
extern unsigned char 							FontXScale;
extern unsigned char 							FontYScale;
extern unsigned char 							FontSpace;

extern unsigned int 							cursorX;		
extern unsigned int 							cursorY;		

extern Lt_Mode										peLETTER;		

flash unsigned char PEmap[63][6] = {
{0xC1,0xC1,0xC1,0xC1,0,0},	
{0xC2,0xC2,0x02,0x02,1,0},	
{0xC3,0xC3,0x01,0x01,1,0},	
{0xC4,0xC4,0xC4,0xC4,0,0},	
{0xC5,0xC5,0x03,0x03,1,0},	
{0xC6,0xC6,0xC6,0xC6,0,0},	
{0xC7,0xC7,0x00,0x00,1,0},	
{0xC8,0x04,0xC8,0x04,1,1},	
{0xC9,0xFE,0xE9,0x95,1,1},	
{0xCA,0x05,0xCA,0x05,1,1},	
{0xCB,0x06,0xCB,0x06,1,1},	
{0xCC,0x07,0x08,0x07,1,1},	
{0xCD,0x09,0x0A,0x09,1,1},	
{0xCE,0x0B,0x0C,0x0B,1,1},	
{0xCF,0xCF,0xCF,0xCF,1,0},	
{0xD0,0xD0,0xD0,0xD0,1,0},	
{0xD1,0xD1,0xD1,0xD1,1,0},	
{0xD2,0xD2,0xD2,0xD2,1,0},	
{0xD3,0x8A,0xD3,0x8A,1,1},	
{0xD4,0x0E,0xD4,0x0E,1,1},	
{0xD5,0x0F,0xD5,0x0F,1,1},	
{0xD6,0x1A,0xD6,0x1A,1,1},	
{0xD7,0xD7,0xD7,0xD7,0,0},	
{0xD8,0xD8,0xD8,0xD8,1,1},	
{0xD9,0xD9,0xD9,0xD9,1,1},	
{0xDA,0x1B,0xF1,0xF0,1,1},	
{0xDB,0xF5,0x7F,0xF6,1,1},	
{0xDC,0xDC,0xDC,0xDC,1,1},	
{0xDD,0x80,0xDD,0x80,1,1},	
{0xDE,0x83,0xDE,0x83,1,1},	
{0xDF,0x8C,0xDF,0x8C,1,1},	
{0xE0,0xE0,0xE0,0xE0,0,0},	
{0xE1,0xF3,0xE1,0xF3,1,1},	
{0xE2,0xE2,0xE2,0xE2,0,0},	
{0xE3,0xF8,0xE3,0xF8,1,1},	
{0xE4,0xF2,0xE4,0xF2,1,1},	
{0xE5,0xFE,0xE7,0x95,1,1},	
{0xE6,0xE6,0xE6,0xE6,1,0},	
{0xE7,0xE7,0xE7,0xE7,0,0},	
{0xE8,0xE8,0xE8,0xE8,0,0},	
{0xE9,0xE9,0xE9,0xE9,0,0},	
{0x81,0xFD,0x81,0xFD,1,1},	
{0x8D,0x9D,0x9E,0x9D,1,1},	
{0xEC,0xC0,0xA0,0xC0,1,1},	
{0xED,0xC0,0x9C,0xC0,1,1},	
{0x8E,0x8E,0x8E,0x8E,1,0},	
{0x90,0xFA,0x90,0xFA,1,1},	
{0xF0,0xF0,0xF0,0xF0,0,0},	
{0xF1,0xF1,0xF1,0xF1,0,0},	
{0xF2,0xF2,0xF2,0xF2,0,0},	
{0xF3,0xF3,0xF3,0xF3,0,0},	
{0xF4,0xF4,0xF4,0xF4,0,0},	
{0xF5,0xF5,0xF5,0xF5,0,0},	
{0xF6,0xF6,0xF6,0xF6,0,0},	
{0xF7,0xF7,0xF7,0xF7,0,0},	
{0xF8,0xF8,0xF8,0xF8,0,0},	
{0xF9,0xF9,0xF9,0xF9,0,0}, 	
{0xFA,0xFA,0xFA,0xFA,0,0}, 	
{0xA5,0xA5,0x9F,0x9F,1,0}, 	
{0xFC,0xFC,0xFC,0xFC,0,0}, 	
{0xFD,0xFD,0xFD,0xFD,0,0}, 	
{0xFE,0xFE,0xFE,0xFE,0,0}, 	
{0xFF,0xFF,0xFF,0xFF,0,0} 	
};

const unsigned char 	   *FontPointer; 									
unsigned char 						rot 						= 0;					
unsigned char 						Reverse					= 0;					
unsigned char							Horizontal			=	1;					

unsigned short 						FgColor 				= ((unsigned int)( (( 0x00  >> 3 )   << 11 ) | 																															 (( 0x00 >> 2 )   << 5  ) | 																																( 0x00   >> 3 )));			
unsigned short 						BkColor 				= ((unsigned int)( (( 0xFF  >> 3 )   << 11 ) | 																															 (( 0xFF >> 2 )   << 5  ) | 																																( 0xFF   >> 3 )));			
unsigned char 						FontFixed				= 0;					
unsigned char							NonTransparence = 0;					

unsigned short 						fontSize;											
unsigned char 						firstchar;										
unsigned char 						lastchar;											
unsigned char 						charwidth;										

unsigned char							FontWidth;										
unsigned char							FontHeight;										
unsigned char 						FontXScale 			= 1;					
unsigned char 						FontYScale 			= 1;					
unsigned char 						FontSpace 			= 1;					

unsigned int 							cursorX 				= 0;					
unsigned int 							cursorY 				= 0;					

Lt_Mode										peLETTER				= E_LETTER;		

unsigned char 						prevLet 				= 0xFF;				
unsigned char	 						nextLet 				= 0xFF; 			

void LcdFont(flash unsigned char *pointer)
{
FontPointer 			= pointer;

FontWidth 				= ((uint8)(FontPointer[2]));
FontHeight				= ((uint8)(FontPointer[3]));

fontSize					=	((uint8)(FontPointer[1])) << 8;
fontSize				 += ((uint8)(FontPointer[0]));
firstchar 				=	((uint8)(FontPointer[5]));
lastchar 					=	((uint8)(FontPointer[6]));
}	

void PutChar(unsigned char c)
{
if(peLETTER == P_LETTER)
PutCharPE(c);
else
PutCharEN(c);
}	

void SetLine(unsigned char line,unsigned char column)
{
if(peLETTER == P_LETTER)
cursorX =((unsigned int)240-1) - (unsigned int)FontWidth  * FontXScale * column;
else
cursorX =(unsigned int)FontWidth  * FontXScale * column;

cursorY =(unsigned int)FontHeight * FontYScale * line;
}	

unsigned int CalcTextWidth(char *Text)
{
if(peLETTER == E_LETTER)
return CalcTextWidthEN(Text);
else
return CalcTextWidthPE(Text);
}	

unsigned int CalcTextHeight(char *Text)
{
return FontHeight * FontYScale;
}	

void Puts(char *Text)
{	
unsigned char 	c;

if(peLETTER == P_LETTER)
PutsPE(Text);
else
{
while((c = *Text++))
PutCharEN(c);
}
}	

void PutsP(char *Text)
{
unsigned char 	c;

while((c = ((uint8)(*(Text++)))))
{
PutChar(c);
}
}	

void PutLong(unsigned long src, unsigned char digit, unsigned char decimal, unsigned char Parameter)
{
char 			text[10+1];
unsigned char 	i;
Lt_Mode		cMode;

cMode = peLETTER;
SetLetter(E_LETTER);

text[digit] = 0;
for(i = digit; i >0; i--)
{
text[i-1] =(src % 10) + 48;
src = src/10;
}

if (Parameter & (1 | 2))
{
while(text[i] == '0')
{

if (Parameter & (1))
PutChar(' ');

i++;
if (i > digit - decimal -1 -1) 
break;
}
}

while(text[i])
{
if (i == digit - decimal) 
PutChar('.');

PutChar(text[i]);
i++;
}

SetLetter(cMode);
}	

void PutInt(unsigned short src, unsigned char digit, unsigned char decimal, unsigned char Parameter)
{
unsigned long 		n = src;

PutLong(n, digit, decimal, Parameter);
}	

void PutByte(unsigned char src, unsigned char digit, unsigned char decimal, unsigned char Parameter)
{
unsigned long 		n = src;

PutLong(n, digit, decimal, Parameter);
}	

void PutText(unsigned short left, unsigned short top, unsigned short right, unsigned short bottom, char *str, unsigned char style)
{
unsigned short 			sizeofstring;

sizeofstring = CalcTextWidth(str);
top = top + (bottom - top - (FontHeight*FontYScale))/2;

if(peLETTER == E_LETTER)
{
switch (style & (0 | 1 | 2))
{
case 0:
left = left + FontSpace;
break;

case 1:
left = left + (right - left - sizeofstring) / 2;
break;

case 2:
if (right > sizeofstring)
left = right - sizeofstring;
break;
}

cursorX = left;
}
else
{
switch (style & (0 | 1 | 2))
{
case 2:
break;

case 1:
right = right - (right - left - sizeofstring) / 2;
break;

case 0:
right = left + sizeofstring;
right = right + FontSpace;
break;
}

cursorX = right;		
}

cursorY = top;
Puts(str);
}	

void PutTextP(unsigned short left, unsigned short top, unsigned short right, unsigned short bottom, const char *str, unsigned char style)
{
char 				strP[100+1];

strncpy(strP, str, strlen(str));
strP[100] = 0;	
PutText(left, top, right, bottom, strP, style);
}	

void TextBox(unsigned short x1, unsigned short y1, unsigned short x2, unsigned short y2, char *str, unsigned char style)
{
unsigned int 			r;
unsigned short 		temp;

if (style & 0x04)
{
r = (style & 0xF0	) >> 4;	
if (r)	
{
if (style & 0x08)
RoundRectangle(x1+1, y1+1, x2-1, y2-1, r, 1, BkColor);

RoundRectangle(x1, y1, x2, y2, r, 0, FgColor);
}
else	
{
if (style & 0x08)
TFTFillRect(x1+1, x2-1, y1+1, y2-1, BkColor, TFT_MODE_NORMAL);

Rectangle(x1, y1, x2, y2, FgColor);
}
}
else if (style & 0x08)
{
TFTFillRect(x1, x2, y1, y2, BkColor, TFT_MODE_NORMAL);
}

if(rot)
{
temp = x1; 		x1 = y1; 		y1 = temp;
temp = x2; 		x2 = y2; 		y2 = temp;
}

if ((style & 0x04) || (style & 0x08))
PutText(x1+1, y1+1, x2-1, y2-1, str, style & (0 | 1 | 2));
else
PutText(x1, y1, x2, y2, str, style & (0 | 1 | 2));
}	

void TextBoxP(unsigned short x1, unsigned short y1, unsigned short x2, unsigned short y2, char *str, unsigned char style)
{
char 		strP[100+1];

strncpy(strP, str, strlen(str));
strP[100] = 0;	
TextBox(x1, y1, x2, y2, strP, style);
}	

void SetLetter(Lt_Mode L)
{
peLETTER = L;

if(L == P_LETTER)
cursorX = ((unsigned int)240-1);
else
cursorX = 0;
}	

void PutsPE(char *str)
{	
unsigned char 	curnLet,	dumyLet;
unsigned char 	Pstat, stat, Nstat;

unsigned char		backFontSpace = FontSpace;
char 						strTemp[50];
unsigned char 	i = 0, j = 0;

while((curnLet = *str++))
{ 		
switch(curnLet)
{	
case 0x81:				
curnLet = 0xEA;
break;
case 0x8D:				
curnLet = 0xEB;
break;
case 0x8E:				
curnLet = 0xEE;
break;
case 0x90:				
curnLet = 0xEF;
break;
case 0xE1:				
nextLet = *str++;

if(nextLet == 0xC7)
curnLet = 0xFB;
else
{
dumyLet = *str--;
curnLet = 0xE1;
}
break;
case 0x3F:				
curnLet = 0xBF;
break;
case 0x3B:				
curnLet = 0x1F;
break;
case 0x2C:				
curnLet = 0x1D;
break;
case 0x2E:				
curnLet = 0x1C;
break; 				
}

nextLet = *str++;
dumyLet	= *str--;

switch(nextLet)
{	
case 0x81:				
nextLet = 0xEA;
break;
case 0x8D:				
nextLet = 0xEB;
break;
case 0x8E:				
nextLet = 0xEE;
break;
case 0x90:				
nextLet = 0xEF;
break;
case 0x3F:				
nextLet = 0xBF;
break;
case 0x3B:				
nextLet = 0x1F;
break;
case 0x2C:				
nextLet = 0x1D;
break;
case 0x2E:				
nextLet = 0x1C;
break; 			
}

if(curnLet > 0xC0)
{		
if(prevLet > 0xC0)
Pstat = (((uint8)((PEmap[prevLet-0xC1][5]))));		
else
Pstat = 0;

if(nextLet > 0xC0)
Nstat = (((uint8)((PEmap[nextLet-0xC1][4]))));		
else
Nstat = 0;

stat = (Pstat<<1) | Nstat;		

if(stat>1)	FontSpace = 0;
else 				FontSpace = backFontSpace;

PutCharPE(((uint8)((PEmap[curnLet-0xC1][stat]))));
FontSpace = backFontSpace;
}
else	
{
if((curnLet >= '0') && (curnLet <= '9'))		
{
i++;
strTemp[i] 	 = curnLet;

if(!((nextLet >= '0') && (nextLet <= '9')))
{
for(j=i; j>0; j--)
PutCharPE(strTemp[j]-0x20);

i = 0;
}
}		
else
PutCharPE(curnLet);
}

prevLet = curnLet;
}

prevLet = 0xFF;
}	

void PutCharPE(unsigned char c)
{
unsigned char 			byte 					= 0;
unsigned char 			bitoffset 		= 0;
unsigned char 			maske 				= 0;
unsigned short 			bcounter 			= 0;
unsigned short 			bitsbischar 	= 0;
unsigned short 			bytesbischar	= 0;
unsigned short 			xPos,yPos;

unsigned char 			Ccounter 			= 0;
unsigned char 			xc 						= 0;
unsigned char 			yc 						= 0;
unsigned char 			sx 						= 0;
unsigned char 			sy 						= 0;

charwidth	= ((uint8)(FontPointer[(unsigned int)(c)+7 					-firstchar]));

if(c == '\n')
{
cursorX = ((unsigned int)240-1);
cursorY = cursorY + (unsigned int)FontHeight * FontYScale; 

return;
}

if( (c < firstchar) || (c > lastchar) || (fontSize == 0)) 
return;

if (charwidth == 0)
return;

if(FontFixed)
charwidth = FontWidth;

if(((int)cursorX - charwidth * FontXScale) < 0)
{
cursorY = cursorY   + (unsigned int)FontHeight * FontYScale; 
cursorX = ((unsigned int)240-1) - (unsigned int)charwidth * FontXScale;
}

cursorX	-= (unsigned int)charwidth * FontXScale + FontSpace;

for(Ccounter = 0; Ccounter < c-firstchar; Ccounter++)
bitsbischar += (((uint8)(FontPointer[(unsigned int)(Ccounter)+7 					])));	

bitsbischar 		*= FontHeight;																										
bitsbischar 		+= (((unsigned short)(lastchar)-firstchar)+7 					)*8;		
bytesbischar 		 = bitsbischar/8;									
bitoffset 			 = bitsbischar % 8;								
maske						 = bitoffset % 8;									

for(xc = 0; xc < charwidth; xc++)
{
for(yc = 0; yc < FontHeight; yc++)
{
if(maske > 7)
{
maske = 0;
bcounter+=1;
}
byte = ((uint8)(FontPointer[bytesbischar + bcounter + 1]));

xPos = (unsigned short)xc*FontXScale + cursorX;

if(Horizontal)	
{
if(Reverse)
yPos = (((unsigned short)FontHeight-yc)*FontYScale + cursorY);
else
yPos = (((unsigned short)yc)*FontYScale + cursorY);     
}
else						
{
if(Reverse)
yPos = (((unsigned short)FontHeight-yc)*FontYScale + cursorY);
else
yPos = (((unsigned short)yc)*FontYScale + cursorY);

}	

for(sx = 0; sx < FontXScale; sx++)
{
for(sy = 0; sy < FontYScale; sy++)
{
if((byte & (1<<(maske))))
{
if(rot)		TFTPutPixel(yPos+sy, xPos+sx, FgColor, TFT_MODE_NORMAL);
else			TFTPutPixel(xPos+sx, yPos+sy, FgColor, TFT_MODE_NORMAL);
}
else
{
if(NonTransparence)
{
if(rot)		TFTPutPixel(yPos+sy, xPos+sx, BkColor, TFT_MODE_NORMAL);
else			TFTPutPixel(xPos+sx, yPos+sy, BkColor, TFT_MODE_NORMAL);
}
}
}
}

maske++;
}
}
}	

void PutCharEN(unsigned char c)
{
unsigned char 			byte 					= 0;
unsigned char 			bitoffset 		= 0;
unsigned char 			maske 				= 0;
unsigned short 			bcounter 			= 0;
unsigned short 			bitsbischar 	= 0;
unsigned short 			bytesbischar	= 0;
unsigned short 			xPos,yPos;

unsigned char 			Ccounter 			= 0;
unsigned char 			xc						= 0;
unsigned char 			yc						= 0;
unsigned char 			sx 						= 0;
unsigned char 			sy 						= 0;

charwidth	= ((uint8)(FontPointer[(unsigned int)(c)+7 					-firstchar]));

if(c == '\n')
{
cursorX = 0;
cursorY = cursorY + (unsigned int)FontHeight * FontYScale; 

return;
}

if( (c < firstchar) || (c > lastchar) || (fontSize == 0)) 
return;

if (charwidth == 0)
return;

if(FontFixed)
charwidth = FontWidth;
else
{

if (((c >= 0xd4) && (c <= 0xda)) || 
((c >= 0xe7) && (c <= 0xec)) ||
(c == 0xd1))
{
cursorX = cursorX - (unsigned int)charwidth * FontXScale;
}
}

if((c >= '0') && (c <= '9'))		
charwidth = ((uint8)(FontPointer[(unsigned int)(7 					)+'0'-firstchar]));		

if(((int)cursorX + charwidth * FontXScale) > ((unsigned int)240-1))
{
cursorY = cursorY + (unsigned int)FontHeight * FontYScale; 
cursorX = 0;
}

for(Ccounter = 0; Ccounter < c-firstchar; Ccounter++)
bitsbischar += (((uint8)(FontPointer[(unsigned int)(Ccounter)+7 					])));	

bitsbischar 		*= FontHeight;																										
bitsbischar 		+= (((unsigned short)(lastchar)-firstchar)+7 					)*8;		
bytesbischar 		 = bitsbischar/8;																
bitoffset 			 = bitsbischar % 8;															
maske						 = bitoffset % 8;																

for(xc = 0; xc < charwidth; xc++)
{
for(yc = 0; yc < FontHeight; yc++)
{
if(maske > 7)
{
maske = 0;
bcounter += 1;
}
byte = ((uint8)(FontPointer[bytesbischar + bcounter + 1]));

xPos = (unsigned short)xc*FontXScale + cursorX;

if(Horizontal)	
{
if(Reverse)
yPos = (((unsigned short)FontHeight-yc)*FontYScale + cursorY);
else
yPos = (((unsigned short)yc)*FontYScale + cursorY);     
}
else						
{
if(Reverse)
yPos = (((unsigned short)FontHeight-yc)*FontYScale + cursorY);
else
yPos = (((unsigned short)yc)*FontYScale + cursorY);

}	

for(sx = 0; sx < FontXScale; sx++)
{
for(sy = 0; sy < FontYScale; sy++)
{
if((byte & (1<<(maske))))
{
if(rot)		TFTPutPixel(yPos+sy, xPos+sx, FgColor, TFT_MODE_NORMAL);
else			TFTPutPixel(xPos+sx, yPos+sy, FgColor, TFT_MODE_NORMAL);
}
else
{
if(NonTransparence)
{
if(rot)		TFTPutPixel(yPos+sy, xPos+sx, BkColor, TFT_MODE_NORMAL);
else			TFTPutPixel(xPos+sx, yPos+sy, BkColor, TFT_MODE_NORMAL);
}
}
};
};

maske++;
};
};

cursorX	+= (unsigned int)charwidth * FontXScale + FontSpace;
}	

unsigned int CalcTextWidthEN(char *str)
{
unsigned int 		strSize = 0;
unsigned char 	c;

while((c = *str++))
{
if(c == '\n')			continue;

if(FontFixed)
strSize += FontWidth * FontXScale;
else
{
if((c < firstchar) || (c > lastchar)) 
charwidth = FontWidth;
else
{
charwidth = ((uint8)(FontPointer[(unsigned int)(c)+7 					-firstchar]));

if (((c >= 0xd4) && (c <= 0xda)) || 
((c >= 0xe7) && (c <= 0xec)) ||
(c == 0xd1))

charwidth = 0;
}

strSize += charwidth * FontXScale;
}

strSize += FontSpace;
}

return strSize ;
}	

unsigned int CalcTextWidthPE(char *str)
{
unsigned char 	curnLet,	dumyLet;
unsigned char 	Pstat, stat, Nstat;

unsigned char		backFontSpace = FontSpace;
unsigned int 		strSize = 0;

while((curnLet = *str++))
{ 		
if(curnLet == '\n')			continue;

if(FontFixed)
strSize += FontWidth * FontXScale;
else
{
if((curnLet < firstchar) || (curnLet > lastchar)) 
charwidth = FontWidth;
else
{
switch(curnLet)
{	
case 0x81:				
curnLet = 0xEA;
break;
case 0x8D:				
curnLet = 0xEB;
break;
case 0x8E:				
curnLet = 0xEE;
break;
case 0x90:				
curnLet = 0xEF;
break;
case 0xE1:				
nextLet = *str++;

if(nextLet == 0xC7)
curnLet = 0xFB;
else
{
dumyLet = *str--;
curnLet = 0xE1;
}
break;
case 0x30:				
case 0x31:
case 0x32:
case 0x33:
case 0x34:
case 0x35:
case 0x36:
case 0x37:
case 0x38:
case 0x39:
curnLet -= 0x20;
break;
case 0x3F:				
curnLet = 0xBF;
break;
case 0x3B:				
curnLet = 0x1F;
break;
case 0x2C:				
curnLet = 0x1D;
break;
case 0x2E:				
curnLet = 0x1C;
break; 				
}

nextLet = *str++;
dumyLet	= *str--;

switch(nextLet)
{	
case 0x81:				
nextLet = 0xEA;
break;
case 0x8D:				
nextLet = 0xEB;
break;
case 0x8E:				
nextLet = 0xEE;
break;
case 0x90:				
nextLet = 0xEF;
break;
case 0x30:				
case 0x31:
case 0x32:
case 0x33:
case 0x34:
case 0x35:
case 0x36:
case 0x37:
case 0x38:
case 0x39:
nextLet -= 0x20;
break; 			
case 0x3F:				
nextLet = 0xBF;
break;
case 0x3B:				
nextLet = 0x1F;
break;
case 0x2C:				
nextLet = 0x1D;
break;
case 0x2E:				
nextLet = 0x1C;
break; 				
}

if(curnLet > 0xC0)
{		
if(prevLet > 0xC0)
Pstat = (((uint8)((PEmap[prevLet-0xC1][5]))));
else
Pstat = 0;

if(nextLet > 0xC0)
Nstat = (((uint8)((PEmap[nextLet-0xC1][4]))));
else
Nstat = 0;

stat = (Pstat<<1) | Nstat;		

if(stat>1)	FontSpace = 0;
else 				FontSpace = backFontSpace;

dumyLet = ((uint8)((PEmap[curnLet-0xC1][stat])));

charwidth = ((uint8)(FontPointer[(unsigned int)(dumyLet)+7 					-firstchar]));
strSize += charwidth * FontXScale;
strSize += FontSpace;

FontSpace = backFontSpace;
}
else
{
charwidth = ((uint8)(FontPointer[(unsigned int)(curnLet)+7 					-firstchar]));
strSize += charwidth * FontXScale;
strSize += FontSpace;
}

prevLet = curnLet;
}
}
}

prevLet = 0xFF;
return strSize ;
}	

